<script>
    import { Canvas } from "@threlte/core";
    import Scene from "./Scene.svelte";
    export let subplot;
    export let xScale;
    import dayjs from "dayjs";
    import duration from "dayjs/plugin/duration";
    import utc from "dayjs/plugin/utc";
    dayjs.extend(duration);
    dayjs.extend(utc);

    $: x_position = subplot.options_3d.x_position; // Get from subplot json in the future
    $: x_current = x_position * (xScale.range()[0] + xScale.range()[1]);
    $: t_current = dayjs.utc(xScale.invert(x_current));
    $: top = subplot.computed.y;
    $: range = xScale.range();
    $: height = subplot.computed.h;
    $: width = range[1] - range[0];
    $: left = range[0] + x_position * (range[1] - range[0]) - 0.5 * width;
</script>

{#if width && subplot.computed.yScale}
    <div
        class="canvas3d"
        style="position: absolute; top: {top}px; left: {left}px; width: {width}px; height: {height}px;">
        <Canvas size={{ width: width, height: height }}>
            <Scene {subplot} {xScale} {width} {height} {x_position} />
        </Canvas>
    </div>
    <svg
        style="position: absolute; top: 0px; left: 0px; width: 100%; height: 100%; pointer-events: none">
        <circle
            cx={x_current}
            cy="{subplot.computed.yScale.range()[0]}px"
            r="5px"
            fill="white"
            fill-opacity="100%"
            stroke="black"
            stroke-width="1" />
        <text
            x={x_current}
            y={subplot.computed.yScale.range()[0] - 10}
            font-size="12px"
            class="fill-white dark:fill-white"
            text-anchor="middle">
            {t_current.format("HH:mm")}
        </text>
    </svg>
{/if}

<style>
    .canvas3d {
        cursor: all-scroll;
    }
</style>
